# TODO: Add comment
# 
# Author: zaugg
###############################################################################


findBestCor=function(
		mat=mat,
		annoTab,
		filename=NULL,
		what='exp.YPD',
		property=NULL,
		new=FALSE,
		projectfolder=getwd()){
	
	correlationfile=ifelse(!is.null(filename),	
			paste(projectfolder,'/',filename,'_bestCor.txt',sep=''),
			paste(projectfolder,'/bestCor.txt',sep=''))
	
	if(is.null(annoTab$YPD.NFR.cat))
		annoTab$YPD.NFR.cat='all'
	annoTab$what=annoTab[[what]] # this is the category that binding is correlated with
# this is to divide the data additionally into different categories
	if(is.null(property)){
		annoTab$property='None'
	} else{
		annoTab$property=annoTab[[property]] 
	}
	annoTab$cor1=NA
	factors=unique(only.text(colnames(mat)))
	df_L=list()
	
	if(!any(is.na(as.numeric(only.text(colnames(mat)))))){
		mat=mat[,order(only.numeric(colnames(mat)))]
	} else{
		mat=mat[,order(only.text(colnames(mat)),only.numeric(colnames(mat)))]
	}
	diff=(diff(only.numeric(colnames(mat))[c(1,2)]))
# positions in bp
	positions=only.numeric(colnames(mat))
# get correlations with positions	
	for(f in factors){
		cat(f,'...','\n')
		for(NFR in unique(annoTab$YPD.NFR.cat)){
			for(PROPERTY in unique(annoTab$property)){
				selN=annoTab$YPD.NFR.cat==NFR&annoTab$property==PROPERTY
				values=annoTab$what[selN]
				names(values)=annoTab$id[selN]
				mm=match(names(values),rownames(mat))
				annoTab[[paste(f,PROPERTY,'cor',sep='')]]=NA
				
# sanity check
				#table(rownames(subMatP)[mm]==subTssT$tx_ID[selN])
				dfL_temp=list()
				for(j in seq(1,40,5)){
					for(i in 1:(ncol(mat)/length(unique(factors))-j)){
						Rmeans=rowMeans(mat[mm,grep(f,colnames(mat))][,i:(i+j)],na.rm=TRUE)
						dfL_temp[[paste(i,j,f,NFR,PROPERTY)]]=c(
								'i'=i,
								'j'=j,
								'factor'=f, # factor
								'interval_start'=positions[i], # interval_start
								'interval_end'=positions[i+j], # interval_end
								'interval_size'=j*diff, # interval size
								'cor_spearman'=cor(Rmeans,values,method='spearman',use='complete.obs'), # spearman correlation
								'cor_pearson'=cor(Rmeans,values,method='pearson',use='complete.obs'), # pearson correlation
								'cor_type'=what, # NFR category
								'NFR_cat'=NFR, # NFR category
								'property'=PROPERTY) # other property to test
					}
				}
				df_P=do.call(rbind,dfL_temp)
				sp=which.max(as.numeric(df_P[,'cor_spearman']))
				pe=which.max(as.numeric(df_P[,'cor_pearson']))
				df_L[[paste(f,what,NFR,PROPERTY,'spearman')]]=df_P[sp,]
				df_L[[paste(f,what,NFR,PROPERTY,'spearman')]]=df_P[pe,]
				ii=which.max(as.numeric(df_P[,'i']))
				jj=which.max(as.numeric(df_P[,'j']))
				annoTab[selN,paste(f,PROPERTY,'cor',sep='')]=rowMeans(mat[mm,grep(f,colnames(mat))][,i:(i+j)],na.rm=TRUE)
			}
		}
	}
	
	df=do.call(rbind,df_L)
	if(new)
		cat(colnames(df),'\n',file=correlationfile)
	for(i in 1:nrow(df)){
		cat(df[i,],'\n',file=correlationfile,append=!new)
		new=FALSE
	}
	cat('written to file',correlationfile,'\n')
	return(list(df,annoTab))
}

